
package net.mcreator.spacecraft_story_mod.world.biome;

import net.minecraftforge.registries.ObjectHolder;
import net.minecraftforge.fml.event.lifecycle.FMLCommonSetupEvent;
import net.minecraftforge.common.BiomeManager;
import net.minecraftforge.common.BiomeDictionary;

import net.minecraft.world.gen.surfacebuilders.SurfaceBuilderConfig;
import net.minecraft.world.gen.surfacebuilders.SurfaceBuilder;
import net.minecraft.world.biome.DefaultBiomeFeatures;
import net.minecraft.world.biome.Biome;
import net.minecraft.entity.EntityClassification;

import net.mcreator.spacecraft_story_mod.entity.AlienShooterEntity;
import net.mcreator.spacecraft_story_mod.entity.AlienEntity;
import net.mcreator.spacecraft_story_mod.block.SuperSteelBlock;
import net.mcreator.spacecraft_story_mod.SpacecraftStoryModModElements;

@SpacecraftStoryModModElements.ModElement.Tag
public class CenterlandBiome extends SpacecraftStoryModModElements.ModElement {
	@ObjectHolder("spacecraft_story_mod:centerland")
	public static final CustomBiome biome = null;
	public CenterlandBiome(SpacecraftStoryModModElements instance) {
		super(instance, 57);
	}

	@Override
	public void initElements() {
		elements.biomes.add(() -> new CustomBiome());
	}

	@Override
	public void init(FMLCommonSetupEvent event) {
		BiomeDictionary.addTypes(biome, BiomeDictionary.Type.PLAINS, BiomeDictionary.Type.DRY);
		BiomeManager.addSpawnBiome(biome);
		BiomeManager.addBiome(BiomeManager.BiomeType.DESERT, new BiomeManager.BiomeEntry(biome, 15));
	}
	static class CustomBiome extends Biome {
		public CustomBiome() {
			super(new Biome.Builder().downfall(0.7f).depth(0.2f).scale(0f).temperature(1.2999999999999998f).precipitation(Biome.RainType.RAIN)
					.category(Biome.Category.NONE).waterColor(4159204).waterFogColor(329011)
					.surfaceBuilder(SurfaceBuilder.DEFAULT, new SurfaceBuilderConfig(SuperSteelBlock.block.getDefaultState(),
							SuperSteelBlock.block.getDefaultState(), SuperSteelBlock.block.getDefaultState())));
			setRegistryName("centerland");
			DefaultBiomeFeatures.addCarvers(this);
			DefaultBiomeFeatures.addStructures(this);
			DefaultBiomeFeatures.addMonsterRooms(this);
			DefaultBiomeFeatures.addOres(this);
			this.addSpawn(EntityClassification.CREATURE, new Biome.SpawnListEntry(AlienEntity.entity, 15, 1, 5));
			this.addSpawn(EntityClassification.CREATURE, new Biome.SpawnListEntry(AlienShooterEntity.entity, 15, 1, 5));
		}
	}
}
